/***********************************************************************/
/*                                                                     */
/*  FILE        :ICS_sample.c                                          */
/*  DATE        :24, August, 2017                                       */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :RX62T                                                 */
/*                                                                     */
/*  NOTE:THIS IS A TYPICAL EXAMPLE.                                    */
/*                                                                     */
/***********************************************************************/

#ifdef  __ICCRX__
  #include "r_cg_macrodriver.h"
  #include <math.h>
#elif   __CCRX__
  #include <machine.h>
  #include <mathf.h>
  #include <stdint.h>
  #include "iodefine.h"
#else
  //
#endif

#include "ICS2_RX62T.h"

void main(void);

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
/* Set option bytes */

#ifdef   __ICCRX__

  #if __LITTLE_ENDIAN__
    #pragma public_equ="__MDES",0xFFFFFFFFUL
  #else
    #pragma public_equ="__MDES",0xFFFFFFF8UL
  #endif

  #pragma public_equ="__OFS0",0xFFFFFFFFUL
  #pragma public_equ="__OFS1",0xFFFFFFFFUL

#elif   __CCRX__  
  
  
#endif


#define   TWOPI    (2.0f*3.1415926535f)
                       // BRR =    1        2    
#define   BRR    0     // @96MHz 1.5Mbps, 1.0Mbps
#define   MODE   3     // 0:16bit 8ch,one time
                       // 1:32bit 8ch,2 times
                       // 2:32bit 4ch,one time
                       // 3:32bit 12ch 3 times

void main(void);

#ifdef  __ICCRX__
  #pragma location=0x03000
  __no_init  uint32_t dtc_table[256]; /* alignment 0x000 */
#elif   __CCRX__
  #pragma address dtc_table=0x03000
  uint32_t dtc_table[256];            /* alignment 0x000 */
#else
#endif

float   wt    = 0.0f;
float   dwt   = TWOPI*50.0f/10000.0f;
float   refu  = 0.0f;
float   refv  = 0.0f;
float   refw  = 0.0f;
float   m     = 1.0f;
float   dm    = 0.0001;
int32_t up    = 0;


void main(void)
{
    SYSTEM.SCKCR.BIT.ICK = 0x00UL; /* VXeNbN(ICLK) EXTAL=12MHẑƂ(96MHz) */
    SYSTEM.SCKCR.BIT.PCK = 0x01UL; /* ӃW[NbN(PCLK) EXTAL=12MHẑƂ(48MHz) */

//******************************************************************************************************
    ics2_init(dtc_table, ICS_SCI0_PB2_PB1, 6U, BRR, MODE); // CN4 Default
//  ics2_init(dtc_table, ICS_SCI1_PD3_PD5, 6U, BRR, MODE); // CN3 if E1 is not used
//  ics2_init(dtc_table, ICS_SCI2_PB5_PB6, 6U, BRR, MODE); // CN1 
//  ics2_init(dtc_table, ICS_SCI2_P81_P80, 6U, BRR, MODE); // CN1 
//******************************************************************************************************

#ifdef  __ICCRX__
    EI();
#elif   __CCRX__
    set_ipl(0); /* set lowest IPL level */
    setpsw_i();  // enable interrput
#else
    //
#endif

    while (1)
    {
        int32_t i;
        
        wt = wt + dwt;
        if (wt>TWOPI) { wt = wt - TWOPI; }
        
        if (up==1)
        {
             m = m + dm;
             if (m>=1.0f) { up = 0; }
        }
        else
        {
             m = m - dm;
             if (m<=0.5f) { up = 1; }
        }

        refu  = m * sinf(wt);
        refv  = m * sinf(wt-TWOPI*1.0f/3.0f);
        refw  = m * sinf(wt-TWOPI*2.0f/3.0f);

        for(i=0;i<5000;i++) { nop(); }

        ics2_watchpoint();
    }
}
